/* quantize/unquantize 8x8 block
 * Copyright (C) 2001,2002,2003  David A. Schleef <ds@schleef.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <specialib/sl_types.h>

#define BLOCK8x8_S16(ptr, stride, row, column) \
	(*((int16_t *)((void *)ptr + stride*row) + column))

/**
 * sl_dequantize8x8_S16:
 * @dst: destination array
 * @dstr: destination row stride
 * @src: source array
 * @sstr: source row stride
 * @quant: quantization array
 * @qstr: quantization row stride
 * #arch C
 *
 * Dequantize an 8x8 block.
 */
SL_FUNC void _sl_dequantize8x8_S16__c(int16_t *dest, int dstr, int16_t *src, int sstr, int16_t *quant, int qstr)
{
	int i,j;

	for(i=0;i<8;i++){
		for(j=0;j<8;j++){
			BLOCK8x8_S16(dest,dstr,i,j) =
				BLOCK8x8_S16(src,sstr,i,j) *
				BLOCK8x8_S16(quant,qstr,i,j);
		}
	}
}


